> ## Documentation Index
> Fetch the complete documentation index at: https://docs.nx1cloud.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Update a data quality rule

> Update a data quality rule's SQL, name, description, or success value.

**Required Role**: nx1_quality



## OpenAPI

````yaml put /api/dq/rules/ids/{dq_id}
openapi: 3.1.0
info:
  title: Nx1 AI API
  description: |

    AI API for Nx1 Data Platform Management and Automated Data Tasks.

    Authentication is required via PSK in Authorization header.

    Default PSK is | [ask a friend] |
  version: 0.10.2
servers: []
security: []
paths:
  /api/dq/rules/ids/{dq_id}:
    put:
      tags:
        - Data quality
      summary: Update a data quality rule
      description: |-
        Update a data quality rule's SQL, name, description, or success value.

        **Required Role**: nx1_quality
      operationId: update_dq_rule_api_dq_rules_ids__dq_id__put
      parameters:
        - name: dq_id
          in: path
          required: true
          schema:
            type: string
            format: uuid
            description: The unique ID of the data quality rule.
            title: Dq Id
          description: The unique ID of the data quality rule.
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/UpdateDQRuleRequest'
      responses:
        '200':
          description: Rule updated.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/DQRule'
        '400':
          description: Bad Request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
        '404':
          description: Rule not found.
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - OAuth2AuthorizationCodeBearer: []
        - APIKeyHeader: []
components:
  schemas:
    UpdateDQRuleRequest:
      properties:
        rule_name:
          anyOf:
            - type: string
            - type: 'null'
          title: Rule Name
          description: Updated rule name.
        rule_description:
          anyOf:
            - type: string
            - type: 'null'
          title: Rule Description
          description: Updated rule description.
        sql:
          anyOf:
            - type: string
            - type: 'null'
          title: Sql
          description: Updated Trino SQL query.
        success_value:
          anyOf:
            - type: string
            - type: 'null'
          title: Success Value
          description: Updated expected success condition.
      type: object
      title: UpdateDQRuleRequest
      description: Request to update a data quality rule.
    DQRule:
      properties:
        id:
          type: string
          format: uuid
          title: Id
          description: Unique ID of the data quality rule.
        rule_name:
          type: string
          title: Rule Name
          description: Name of the data quality rule.
        rule_description:
          type: string
          title: Rule Description
          description: Brief explanation of what the rule checks.
        sql:
          type: string
          title: Sql
          description: Trino SQL query used to validate the rule.
        accepted:
          type: boolean
          title: Accepted
          description: Whether you have accepted this rule.
        table:
          type: string
          title: Table
          description: The database table this rule applies to.
        external_id:
          anyOf:
            - type: string
            - type: 'null'
          title: External Id
          description: Uniform Resource Name (URN) of the assertion in DataHub.
        spark_sql:
          anyOf:
            - type: string
            - type: 'null'
          title: Spark Sql
          description: Spark SQL query of the rule, if applicable.
        success_value:
          anyOf:
            - type: string
            - type: 'null'
          title: Success Value
          description: Expected success condition for this rule.
      type: object
      required:
        - id
        - rule_name
        - rule_description
        - sql
        - accepted
        - table
      title: DQRule
    ErrorResponse:
      properties:
        error:
          type: string
          title: Error
          description: A brief description of the error that occurred.
        code:
          type: integer
          title: Code
          description: The HTTP status code associated with the error.
          default: 500
      type: object
      required:
        - error
      title: ErrorResponse
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
        input:
          title: Input
        ctx:
          type: object
          title: Context
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
  securitySchemes:
    OAuth2AuthorizationCodeBearer:
      type: oauth2
      flows:
        authorizationCode:
          scopes: {}
          authorizationUrl: >-
            https://sso-rapid.rapid.nx1cloud.com/realms/rapid/protocol/openid-connect/auth
          tokenUrl: >-
            https://sso-rapid.rapid.nx1cloud.com/realms/rapid/protocol/openid-connect/token
    APIKeyHeader:
      type: apiKey
      in: header
      name: Authorization-PSK

````